Loading...
Searching...
No Matches
Sip_retry_after

## Data Structures

struct | sip_retry_after_s
| Structure for Retry-After header. More...

## Macros

#define | sip_retry_after(sip)
| Access a SIP Retry-After header structure sip_retry_after_t from sip_t.
#define | SIP_RETRY_AFTER_INIT()
| Initializer for structure sip_retry_after_t.
#define | SIPTAG_RETRY_AFTER(x)
| Tag list item for pointer to a Retry-After header structure sip_retry_after_t.
#define | SIPTAG_RETRY_AFTER_REF(x)
| Tag list item for reference to a Retry-After header pointer.
#define | SIPTAG_RETRY_AFTER_STR(s)
| Tag list item for string with Retry-After header value.
#define | SIPTAG_RETRY_AFTER_STR_REF(x)
| Tag list item for reference to a Retry-After header string.

## Typedefs

typedef struct sip_retry_after_s | sip_retry_after_t
| @

## Functions

issize_t | sip_retry_after_d (su_home_t *, msg_header_t *, char *s, isize_t slen)
| Parse a SIP Retry-After header.
issize_t | sip_retry_after_e (char b[], isize_t bsiz, msg_header_t const *h, int flags)
| Print a SIP Retry-After header.
sip_retry_after_t * | sip_retry_after_init (sip_retry_after_t x[1])
| Initialize a structure sip_retry_after_t.
int | sip_is_retry_after (sip_header_t const *header)
| Test if header object is instance of sip_retry_after_t.
sip_retry_after_t * | sip_retry_after_dup (su_home_t *home, sip_retry_after_t const *hdr))
| Duplicate a list of Retry-After header header structures sip_retry_after_t.
sip_retry_after_t * | sip_retry_after_copy (su_home_t *home, sip_retry_after_t const *hdr))
| Copy a list of Retry-After header header structures sip_retry_after_t.
sip_retry_after_t * | sip_retry_after_make (su_home_t *home, char const *s))
| Make a Retry-After header structure sip_retry_after_t.
sip_retry_after_t * | sip_retry_after_format (su_home_t *home, char const *fmt,...)))
| Make a Retry-After header from formatting result.

## Variables

msg_hclass_t | sip_retry_after_class []
| Header class for Retry-After header.
tag_typedef_t | siptag_retry_after
| Tag for Retry-After header object.
tag_typedef_t | siptag_retry_after_str
| Tag for string with Retry-After header value.

## Detailed Description

## Macro Definition Documentation

## SIP_RETRY_AFTER_INIT

#define SIP_RETRY_AFTER_INIT | ( |  | ) |

Initializer for structure sip_retry_after_t.

A static sip_retry_after_t structure for Retry-After header must be initialized with the SIP_RETRY_AFTER_INIT() macro. For instance,

sip_retry_after_t sip_retry_after = SIP_RETRY_AFTER_INIT;
sip_retry_after_t
struct sip_retry_after_s sip_retry_after_t
@
Definition sip.h:186
sip_retry_after
#define sip_retry_after(sip)
Access a SIP Retry-After header structure sip_retry_after_t from sip_t.
Definition sip_protos.h:4653
SIP_RETRY_AFTER_INIT
#define SIP_RETRY_AFTER_INIT()
Initializer for structure sip_retry_after_t.
Definition sip_protos.h:4670

## SIPTAG_RETRY_AFTER

#define SIPTAG_RETRY_AFTER | ( |  | x | ) |

Tag list item for pointer to a Retry-After header structure sip_retry_after_t.

The SIPTAG_RETRY_AFTER() macro is used to include a tag item with a pointer to a sip_retry_after_t structure in a tag list.

Parameters

  x | pointer to a sip_retry_after_t structure, or NULL.

The corresponding tag taking reference parameter is SIPTAG_RETRY_AFTER_REF().

## SIPTAG_RETRY_AFTER_STR

#define SIPTAG_RETRY_AFTER_STR | ( |  | s | ) |

Tag list item for string with Retry-After header value.

The SIPTAG_RETRY_AFTER_STR() macro is used to include a tag item with a string containing value of a sip_retry_after_t header in a tag list.

Parameters

  s | pointer to a string containing Retry-After header value, or NULL.

The string in SIPTAG_RETRY_AFTER_STR() can be converted to a sip_retry_after_t header structure by giving the string s has second argument to function sip_retry_after_make().

The corresponding tag taking reference parameter is SIPTAG_RETRY_AFTER_STR_REF().

## Typedef Documentation

## sip_retry_after_t

typedef struct sip_retry_after_s sip_retry_after_t

@

The Retry-After response-header field RFC 3261 section 20.33 can be used to indicate how long the service is expected to be unavailable or when the called party anticipates being available again. Its syntax is defined in RFC 3261 as follows:

Retry-After = "Retry-After" HCOLON delta-seconds
[ comment ] *( SEMI retry-param )
retry-param = ("duration" EQUAL delta-seconds)
/ generic-param

The parsed Retry-After header is stored in sip_retry_after_t structure.

The structure sip_retry_after_t contains representation of an Retry-After header.

The sip_retry_after_t is defined as follows:

typedef struct sip_retry_after_s {
sip_common_t af_common[1]; // Common fragment info
sip_error_t *af_next; // Link to next (dummy)
sip_time_t af_delta; // Seconds to before retry
char const *af_comment; // Comment string
msg_param_t const *af_params; // List of parameters
char const *af_duration; // Duration parameter
} sip_retry_after_t;
sip_error_t
msg_error_t sip_error_t
@
Definition sip.h:134
sip_common_t
msg_common_t sip_common_t
Common part of all the header structures.
Definition sip.h:121
sip_time_t
msg_time_t sip_time_t
Time in seconds since Jan 01 1900.
Definition sip.h:105
sip_retry_after_s
Structure for Retry-After header.
Definition sip.h:632
sip_retry_after_s::af_next
sip_error_t * af_next
Link to next (dummy).
Definition sip.h:634
sip_retry_after_s::af_comment
char const * af_comment
Comment string.
Definition sip.h:636
sip_retry_after_s::af_common
sip_common_t af_common[1]
Common fragment info.
Definition sip.h:633
sip_retry_after_s::af_params
msg_param_t const * af_params
List of parameters.
Definition sip.h:637
sip_retry_after_s::af_delta
sip_time_t af_delta
Seconds to before retry.
Definition sip.h:635
sip_retry_after_s::af_duration
char const * af_duration
Value of "duration" parameter.
Definition sip.h:638

## Function Documentation

## sip_is_retry_after()

int sip_is_retry_after | ( | sip_header_t const * | header | ) |

inline

Test if header object is instance of sip_retry_after_t.

Check if the header class is an instance of Retry-After header object and return true (nonzero), otherwise return false (zero).

Parameters

  header | pointer to the header structure to be tested

Return values

  1 | (true) if the header is an instance of header retry_after
  0 | (false) otherwise

## sip_retry_after_copy()

sip_retry_after_t * sip_retry_after_copy | ( | su_home_t * | home,
|  | sip_retry_after_t const * | hdr )

inline

Copy a list of Retry-After header header structures sip_retry_after_t.

The function sip_retry_after_copy() copies a header structure hdr. If the header structure hdr contains a reference (`hdr->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the list of header structure hdr.

Parameters

  home | memory home used to allocate new structure
  hdr | pointer to the header structure to be copied

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old hdr header, including the encoding of the old header, if present.

Example
  retry_after = sip_retry_after_copy(home, sip->sip_retry_after);
  sip_retry_after_copy
  sip_retry_after_t * sip_retry_after_copy(su_home_t *home, sip_retry_after_t const *hdr))
  Copy a list of Retry-After header header structures sip_retry_after_t.
  Definition sip_protos.h:4800

Returns
  A pointer to newly copied header structure, or NULL upon an error.

## sip_retry_after_dup()

sip_retry_after_t * sip_retry_after_dup | ( | su_home_t * | home,
|  | sip_retry_after_t const * | hdr )

inline

Duplicate a list of Retry-After header header structures sip_retry_after_t.

Duplicate a header structure hdr. If the header structure hdr contains a reference (`hdr->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  hdr | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  retry_after = sip_retry_after_dup(home, sip->sip_retry_after);
  sip_retry_after_dup
  sip_retry_after_t * sip_retry_after_dup(su_home_t *home, sip_retry_after_t const *hdr))
  Duplicate a list of Retry-After header header structures sip_retry_after_t.
  Definition sip_protos.h:4757

Returns
  A pointer to the newly duplicated sip_retry_after_t header structure, or NULL upon an error.

## sip_retry_after_format()

sip_retry_after_t * sip_retry_after_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a Retry-After header from formatting result.

Make a new sip_retry_after_t object using formatting result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and parses the formatting result to the structure sip_retry_after_t.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Returns
  A pointer to newly makes header structure, or NULL upon an error.

## sip_retry_after_init()

sip_retry_after_t * sip_retry_after_init | ( | sip_retry_after_t | x[1] | ) |

inline

Initialize a structure sip_retry_after_t.

An sip_retry_after_t structure for Retry-After header can be initialized with the sip_retry_after_init() function/macro. For instance,

sip_retry_after_t sip_retry_after;
sip_retry_after_init(&sip_retry_after);
sip_retry_after_init
sip_retry_after_t * sip_retry_after_init(sip_retry_after_t x[1])
Initialize a structure sip_retry_after_t.
Definition sip_protos.h:4688

## sip_retry_after_make()

sip_retry_after_t * sip_retry_after_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a Retry-After header structure sip_retry_after_t.

The function sip_retry_after_make() makes a new sip_retry_after_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Returns
  A pointer to newly maked sip_retry_after_t header structure, or NULL upon an error.

## Variable Documentation

## sip_retry_after_class

msg_hclass_t sip_retry_after_class[]

extern

Header class for Retry-After header.

The header class sip_retry_after_class defines how a SIP Retry-After header is parsed and printed. It also contains methods used by SIP parser and other functions to manipulate the sip_retry_after_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.